/// @cond EO_CXX_EO_IMPL

#ifdef ELM_INTERFACE_ATSPI_WIDGET_ACTION_PROTECTED
inline const Elm_Atspi_Action * elm_interface_atspi_widget_action::elm_actions_get() const
{
   const Elm_Atspi_Action * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_atspi_widget_action_elm_actions_get());
   return _tmp_ret;
}
#endif

#ifdef ELM_INTERFACE_ATSPI_WIDGET_ACTION_PROTECTED
inline const Elm_Atspi_Action * eo_cxx::elm_interface_atspi_widget_action::elm_actions_get() const
{
   const Elm_Atspi_Action * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_interface_atspi_widget_action_elm_actions_get());
   return _tmp_ret;
}
#endif

inline ::eo_cxx::elm_interface_atspi_widget_action::operator ::elm_interface_atspi_widget_action() const
{
   return *static_cast<::elm_interface_atspi_widget_action const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm_interface_atspi_widget_action::operator ::elm_interface_atspi_widget_action&()
{
   return *static_cast<::elm_interface_atspi_widget_action*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm_interface_atspi_widget_action::operator ::elm_interface_atspi_widget_action const&() const
{
   return *static_cast<::elm_interface_atspi_widget_action const*>(static_cast<void const*>(this));
}

#ifdef ELM_INTERFACE_ATSPI_WIDGET_ACTION_PROTECTED
template <typename T>
const Elm_Atspi_Action * _elm_interface_atspi_widget_action_elm_actions_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->elm_actions_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         const Elm_Atspi_Action * _tmp_ret{};
         return _tmp_ret;
      }
}
#endif

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm_interface_atspi_widget_action >
{
   template <typename T>
   struct type
         : virtual operations< ::elm_interface_atspi_action >::template type<T>
   {
#ifdef ELM_INTERFACE_ATSPI_WIDGET_ACTION_PROTECTED
      virtual const Elm_Atspi_Action * elm_actions_get()
      {
         const Elm_Atspi_Action * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_interface_atspi_widget_action_elm_actions_get());
            return _tmp_ret;
      }
#endif

   };
};


template<>
struct operation_description_class_size< ::elm_interface_atspi_widget_action >
{
   static constexpr int value = 
#if defined(ELM_INTERFACE_ATSPI_WIDGET_ACTION_PROTECTED) && defined(ELM_INTERFACE_ATSPI_WIDGET_ACTION_BETA)
      1
#elif defined(ELM_INTERFACE_ATSPI_WIDGET_ACTION_PROTECTED)
      1
#elif defined(ELM_INTERFACE_ATSPI_WIDGET_ACTION_BETA)
      0
#else
      0
#endif
      + operation_description_class_size<::elm_interface_atspi_action >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm_interface_atspi_widget_action>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
#ifdef ELM_INTERFACE_ATSPI_WIDGET_ACTION_PROTECTED
   ops[i].func = reinterpret_cast<void*>(& ::_elm_interface_atspi_widget_action_elm_actions_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_interface_atspi_widget_action_elm_actions_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;
#endif

   initialize_operation_description<T>(::efl::eo::detail::tag<::elm_interface_atspi_action>(), &ops[operation_description_class_size< ::elm_interface_atspi_widget_action >::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm_interface_atspi_widget_action>)
{
   return (ELM_INTERFACE_ATSPI_WIDGET_ACTION_MIXIN);
}

} } }

/// @endcond

